"use strict";
(function(global) {
if (typeof newscrollbarsjso == "undefined") {var newscrollbarsjso = {};};
if (!newscrollbarsjso.ns) {newscrollbarsjso.ns = {};};

var Cc = Components.classes, Ci = Components.interfaces, Cu = Components.utils;

var {Services} = Cu.import("resource://gre/modules/Services.jsm", {});

newscrollbarsjso.ns = {

  prefs: Services.prefs.getBranch("extensions.noiascrollbars-extension."),

  initprefwindow: function() {

	// make 'OK' button visible on all OS
	document.getElementById('nsaddon_pw_okbutton').style.display = 'block';
	document.getElementById('nsaddon_pw_okbutton').disabled = false;
	
	function PrefListener(branch_name, callback) {

	  this._branch = Services.prefs.getBranch(branch_name);
	  this._branch.QueryInterface(Ci.nsIPrefBranch2);
	  this._callback = callback;
	}

	PrefListener.prototype.observe = function(subject, topic, data) {
	  if (topic == 'nsPref:changed')
		this._callback(this._branch, data);
	};

	PrefListener.prototype.register = function(trigger) {
	  this._branch.addObserver('', this, false);
	  if (trigger) {
		var that = this;
		this._branch.getChildList('', {}).
		  forEach(function (pref_leaf_name)
			{ that._callback(that._branch, pref_leaf_name); });
	  }
	};

	PrefListener.prototype.unregister = function() {
	  if (this._branch)
		this._branch.removeObserver('', this);
	};
	
	var nsSettingsListener = new PrefListener(
	  "extensions.noiascrollbars-extension.",
	  function(branch, name) {
		switch (name) {

		  case "nowused":
		  
		    if(branch.getCharPref("nowused")=='predefined') {
			  document.getElementById("predefglabel").style.color = "blue";
			  document.getElementById("custom1glabel").style.color = "inherit";
			  document.getElementById("custom2glabel").style.color = "inherit";
			} else if(branch.getCharPref("nowused")=='custom1') {
			  document.getElementById("predefglabel").style.color = "inherit";
			  document.getElementById("custom1glabel").style.color = "blue";
			  document.getElementById("custom2glabel").style.color = "inherit";
			} else if(branch.getCharPref("nowused")=='custom2') {
			  document.getElementById("predefglabel").style.color = "inherit";
			  document.getElementById("custom1glabel").style.color = "inherit";
			  document.getElementById("custom2glabel").style.color = "blue";
			} else {
			  document.getElementById("predefglabel").style.color = "inherit";
			  document.getElementById("custom1glabel").style.color = "inherit";
			  document.getElementById("custom2glabel").style.color = "inherit";
			}
			
			if(branch.getCharPref("nowused")=='none') {
			  document.getElementById('NoScrbutton').disabled = true;	
			  document.getElementById('None_Vertical').disabled = true;	
			  document.getElementById('None_Horizontal').disabled = true;
			} else {
			  document.getElementById('NoScrbutton').disabled = false;
			  document.getElementById('None_Vertical').disabled = false;	
			  document.getElementById('None_Horizontal').disabled = false;	
			}
			
			if(branch.getCharPref("nowused")=='predefined' || branch.getCharPref("nowused")=='custom1') {
			  document.getElementById('NoCaps').disabled = false;	
			} else {
			  document.getElementById('NoCaps').disabled = true;	
			}

		  break;

		}
	  }
	);
	
	nsSettingsListener.register(true);
	
	window.addEventListener("unload", function unregisterListener(event){
	
		nsSettingsListener.unregister();
		
		window.removeEventListener("unload", unregisterListener, false);
		
	},false);

  },
  
  openHelp: function() {
	openDialog("chrome://noiascrollbars-extension/content/help/help.html", "", "scrollbars=yes, resizable=yes, width=600, height=600");
  }

};

  global.newscrollbarsjso = newscrollbarsjso;
}(this));