"use strict";

(function(global) {

var Cc = Components.classes, Ci = Components.interfaces, Cu = Components.utils;

var {Services} = Cu.import("resource://gre/modules/Services.jsm", {});

if (typeof newscrollbarsjs == "undefined") {var newscrollbarsjs = {};};
if (!newscrollbarsjs.ns) {newscrollbarsjs.ns = {};};

newscrollbarsjs.ns = {
  
  custom1:				Services.io.newURI("data:text/css;charset=utf-8," + encodeURIComponent(''), null, null),
  custom2:				Services.io.newURI("data:text/css;charset=utf-8," + encodeURIComponent(''), null, null),

  prefs:				Services.prefs.getBranch("extensions.noiascrollbars-extension."),
  defaulttheme:			Services.prefs.getBranch("general.skins.").getCharPref("selectedSkin") == 'classic/1.0',

  init: function() {
	  
	// predefined scrollbars randomize option
	if (this.prefs.getBoolPref("randomize")){
				
	  // generate value: 1-28
	  var randomnumber=Math.floor(Math.random()*29);

	  switch (randomnumber) {
					
		case 1:  this.prefs.setCharPref("predeflist","lightblue"); break;
		case 2:  this.prefs.setCharPref("predeflist","red"); break;
		case 3:  this.prefs.setCharPref("predeflist","green"); break;
		case 4:  this.prefs.setCharPref("predeflist","blue"); break;
		case 5:  this.prefs.setCharPref("predeflist","orange"); break;
		case 6:  this.prefs.setCharPref("predeflist","pink"); break;
		case 7:  this.prefs.setCharPref("predeflist","yellow"); break;
		case 8:  this.prefs.setCharPref("predeflist","lightblue_d"); break;
		case 9:  this.prefs.setCharPref("predeflist","red_d"); break;
		case 10: this.prefs.setCharPref("predeflist","green_d"); break;
		case 11: this.prefs.setCharPref("predeflist","blue_d"); break;
		case 12: this.prefs.setCharPref("predeflist","orange_d"); break;
		case 13: this.prefs.setCharPref("predeflist","pink_d"); break;
		case 14: this.prefs.setCharPref("predeflist","yellow_d"); break;
		case 15: this.prefs.setCharPref("predeflist","lightblue-w"); break;
		case 16: this.prefs.setCharPref("predeflist","red-w"); break;
		case 17: this.prefs.setCharPref("predeflist","green-w"); break;
		case 18: this.prefs.setCharPref("predeflist","blue-w"); break;
		case 19: this.prefs.setCharPref("predeflist","orange-w"); break;
		case 20: this.prefs.setCharPref("predeflist","pink-w"); break;
		case 21: this.prefs.setCharPref("predeflist","yellow-w"); break;
		case 22: this.prefs.setCharPref("predeflist","lightblue_d-w"); break;
		case 23: this.prefs.setCharPref("predeflist","red_d-w"); break;
		case 24: this.prefs.setCharPref("predeflist","green_d-w"); break;
		case 25: this.prefs.setCharPref("predeflist","blue_d-w"); break;
		case 26: this.prefs.setCharPref("predeflist","orange_d-w"); break;
		case 27: this.prefs.setCharPref("predeflist","pink_d-w"); break;
		case 28: this.prefs.setCharPref("predeflist","yellow_d-w"); break;
	  }
	}
			
	// Preferences listener
	function PrefListener(branch_name, callback) {

	  this._branch = Services.prefs.getBranch(branch_name);
	  this._branch.QueryInterface(Ci.nsIPrefBranch2);
	  this._callback = callback;
	}

	PrefListener.prototype.observe = function(subject, topic, data) {
	  if (topic == 'nsPref:changed')
		this._callback(this._branch, data);
	};

	PrefListener.prototype.register = function(trigger) {
	  this._branch.addObserver('', this, false);
	  if (trigger) {
		var that = this;
		this._branch.getChildList('', {}).
		  forEach(function (pref_leaf_name)
			{ that._callback(that._branch, pref_leaf_name); });
	  }
	};

	PrefListener.prototype.unregister = function() {
	  if (this._branch)
		this._branch.removeObserver('', this);
	};

	var nsSettingsListener = new PrefListener(
	  "extensions.noiascrollbars-extension.",
	  function(branch, name) {
		switch (name) {
			
		  case "options_gui":
			if (branch.getBoolPref("options_gui") && newscrollbarsjs.ns.defaulttheme==true) newscrollbarsjs.ns.loadUnloadCSS("options_gui",true);
			  else newscrollbarsjs.ns.loadUnloadCSS("options_gui",false);
		  break;
			
		  case "noscrbutton":
			if (branch.getBoolPref("noscrbutton")) newscrollbarsjs.ns.loadUnloadCSS("noscrbutton",true);
			  else newscrollbarsjs.ns.loadUnloadCSS("noscrbutton",false);
		  break;
		  
		  case "nocaps":
			if (branch.getBoolPref("nocaps")) newscrollbarsjs.ns.loadUnloadCSS("nocaps",true);
			  else newscrollbarsjs.ns.loadUnloadCSS("nocaps",false);
		  break;
		  
		  case "none_v":
			if (branch.getBoolPref("none_v")) newscrollbarsjs.ns.loadUnloadCSS("none_v",true);
			  else newscrollbarsjs.ns.loadUnloadCSS("none_v",false);
		  break;
		  
		  case "none_h":
			if (branch.getBoolPref("none_h")) newscrollbarsjs.ns.loadUnloadCSS("none_h",true);
			  else newscrollbarsjs.ns.loadUnloadCSS("none_h",false);
		  break;
		  
		  case "nowused": case "predeflist":
			newscrollbarsjs.ns.loadUnloadCSS('none',false);
			newscrollbarsjs.ns.loadUnloadCSS('transparent',false);
			newscrollbarsjs.ns.loadUnloadCSS('transparent2',false);
			newscrollbarsjs.ns.loadUnloadCSS('custom1',false);
			newscrollbarsjs.ns.loadUnloadCSS('custom2',false);

			newscrollbarsjs.ns.loadUnloadCSS('lightblue',false);
			newscrollbarsjs.ns.loadUnloadCSS('red',false);
			newscrollbarsjs.ns.loadUnloadCSS('green',false);	
			newscrollbarsjs.ns.loadUnloadCSS('blue',false);
			newscrollbarsjs.ns.loadUnloadCSS('orange',false);
			newscrollbarsjs.ns.loadUnloadCSS('pink',false);
			newscrollbarsjs.ns.loadUnloadCSS('yellow',false);	
			
			newscrollbarsjs.ns.loadUnloadCSS('lightblue_d',false);
			newscrollbarsjs.ns.loadUnloadCSS('red_d',false);
			newscrollbarsjs.ns.loadUnloadCSS('green_d',false);	
			newscrollbarsjs.ns.loadUnloadCSS('blue_d',false);
			newscrollbarsjs.ns.loadUnloadCSS('orange_d',false);
			newscrollbarsjs.ns.loadUnloadCSS('pink_d',false);
			newscrollbarsjs.ns.loadUnloadCSS('yellow_d',false);
			
			newscrollbarsjs.ns.loadUnloadCSS('lightblue-w',false);
			newscrollbarsjs.ns.loadUnloadCSS('red-w',false);
			newscrollbarsjs.ns.loadUnloadCSS('green-w',false);	
			newscrollbarsjs.ns.loadUnloadCSS('blue-w',false);
			newscrollbarsjs.ns.loadUnloadCSS('orange-w',false);
			newscrollbarsjs.ns.loadUnloadCSS('pink-w',false);
			newscrollbarsjs.ns.loadUnloadCSS('yellow-w',false);	

			newscrollbarsjs.ns.loadUnloadCSS('lightblue_d-w',false);
			newscrollbarsjs.ns.loadUnloadCSS('red_d-w',false);
			newscrollbarsjs.ns.loadUnloadCSS('green_d-w',false);	
			newscrollbarsjs.ns.loadUnloadCSS('blue_d-w',false);
			newscrollbarsjs.ns.loadUnloadCSS('orange_d-w',false);
			newscrollbarsjs.ns.loadUnloadCSS('pink_d-w',false);
			newscrollbarsjs.ns.loadUnloadCSS('yellow_d-w',false);
			
		    newscrollbarsjs.ns.loadUnloadCSS("c1bglight",false);
			newscrollbarsjs.ns.loadUnloadCSS("c1bgdark",false);
			newscrollbarsjs.ns.loadUnloadCSS("c1gradlight",false);
			newscrollbarsjs.ns.loadUnloadCSS("c1graddark",false);
			
			newscrollbarsjs.ns.loadUnloadCSS("c2lightgradient",false);
			newscrollbarsjs.ns.loadUnloadCSS("c2darkgradient",false);

			if (branch.getCharPref("nowused")!="default" && branch.getCharPref("nowused")!="predefined"){
			  newscrollbarsjs.ns.loadUnloadCSS(branch.getCharPref("nowused"),true);
			} else if (branch.getCharPref("nowused")=="predefined") {
			  newscrollbarsjs.ns.loadUnloadCSS(branch.getCharPref("predeflist"),true);
			}
			
			if (branch.getCharPref("nowused")=="custom1" && branch.getIntPref("custom1_width") < 17)
			  newscrollbarsjs.ns.loadUnloadCSS("menupopupfix",true);
			else if (branch.getCharPref("nowused")=="custom2" && branch.getIntPref("custom2_size") < 17)
			  newscrollbarsjs.ns.loadUnloadCSS("menupopupfix",true);
			else  newscrollbarsjs.ns.loadUnloadCSS("menupopupfix",false);
	  
		  break;
		  
		  case "predefined":
			if (branch.getCharPref("predefined") && branch.getCharPref("nowused")=="predefined")
			  newscrollbarsjs.ns.loadUnloadCSS("predefined",true);
			else newscrollbarsjs.ns.loadUnloadCSS("predefined",false);
		  break;
		  
		  case "custom1_colorpicker_thumb": case "custom1_width":
			if (branch.getCharPref("nowused")=="custom1"){
			  newscrollbarsjs.ns.loadUnloadCSS("custom1",true);
			}
			
			if (branch.getIntPref("custom1_width") < 17){
			  newscrollbarsjs.ns.loadUnloadCSS("menupopupfix",true);
			} else {
			  newscrollbarsjs.ns.loadUnloadCSS("menupopupfix",false);
			}
		  break;
		  
		  case "custom1_bg":
		    newscrollbarsjs.ns.loadUnloadCSS("c1bglight",false);
			newscrollbarsjs.ns.loadUnloadCSS("c1bgdark",false);
			
			if (branch.getCharPref("nowused")=="custom1"){
			  newscrollbarsjs.ns.loadUnloadCSS(branch.getCharPref("custom1_bg"),true);
			}
		  break;
		  
		  case "custom1_grad":
		    newscrollbarsjs.ns.loadUnloadCSS("c1gradlight",false);
			newscrollbarsjs.ns.loadUnloadCSS("c1graddark",false);
			
			if (branch.getCharPref("nowused")=="custom1"){
			  newscrollbarsjs.ns.loadUnloadCSS(branch.getCharPref("custom1_grad"),true);
			}
		  break;
		  
		  case "custom2_colorpicker_bg":
		  case "custom2_colorpicker_thumb": case "custom2_colorpicker_thumb_h":
		  case "custom2_colorpicker_but": case "custom2_colorpicker_but_h":
		  case "custom2_size": case "custom2_borderradius": case "custom2_butborderradius":
		  case "custom2_bg":
		  case "custom2_scr_onhtml": case "custom2_opacity": case "custom2_thumb_border":
			if (branch.getCharPref("nowused")=="custom2"){
			  newscrollbarsjs.ns.loadUnloadCSS("custom2",true);
			}
			
			if (branch.getIntPref("custom2_size") < 17){
			  newscrollbarsjs.ns.loadUnloadCSS("menupopupfix",true);
			} else {
			  newscrollbarsjs.ns.loadUnloadCSS("menupopupfix",false);
			}
		  break;
		  
		  case "custom2_grad":
		    newscrollbarsjs.ns.loadUnloadCSS("c2lightgradient",false);
			newscrollbarsjs.ns.loadUnloadCSS("c2darkgradient",false);
			
			if (branch.getCharPref("custom2_grad")!="c2nogradient" && branch.getCharPref("nowused")=="custom2"){
			  newscrollbarsjs.ns.loadUnloadCSS(branch.getCharPref("custom2_grad"),true);
			}
		  break;
		  
		}
	  }
	);

	nsSettingsListener.register(true);

	// Remove current windows preference listeners once the window gets closed
	// to prevent memory leaks and other issues in a multi window environment.
	window.addEventListener("unload", function unregisterNSListeners(event){
	
	  nsSettingsListener.unregister();
		
	  window.removeEventListener("unload", unregisterNSListeners, false);
		
	},false);

  },

  /* enable/disable css sheets*/
  loadUnloadCSS: function(which,enable) {
	
	var ios = Services.io;
	
	switch (which) {
		
	  case "options_gui": 		manageCSS("options_gui.css"); 				break;
	  case "noscrbutton": 		manageCSS("no_scrollbarbuttons.css"); 		break;
	  case "nocaps": 			manageCSS("no_scrollbarcaps.css"); 			break;  
	
	  case "none": 				manageCSS("no_scrollbars.css");  			break;
	  case "none_v": 			manageCSS("no_scrollbars_vert.css");  		break;
	  case "none_h": 			manageCSS("no_scrollbars_hor.css");  		break;
	  case "transparent": 		manageCSS("transparent_scrollbars.css");  	break;
	  case "transparent2": 		manageCSS("transparent_scrollbars_v2.css");	break;
	  
	  case "lightblue":			manageCSS("scrollbars_lightblue.css"); manageCSS("fix_devtools.css"); break;
	  case "red":				manageCSS("scrollbars_red.css"); manageCSS("fix_devtools.css"); break;
	  case "green":				manageCSS("scrollbars_green.css"); manageCSS("fix_devtools.css"); break;	
	  case "blue":				manageCSS("scrollbars_blue.css"); manageCSS("fix_devtools.css"); break;
	  case "orange":			manageCSS("scrollbars_orange.css"); manageCSS("fix_devtools.css"); break;
	  case "pink":				manageCSS("scrollbars_pink.css"); manageCSS("fix_devtools.css"); break;
	  case "yellow":			manageCSS("scrollbars_yellow.css"); manageCSS("fix_devtools.css"); break;	
			
	  case "lightblue_d": 		manageCSS("scrollbars_lightbluedark.css"); manageCSS("fix_devtools.css"); break;
	  case "red_d":				manageCSS("scrollbars_reddark.css"); manageCSS("fix_devtools.css"); break;
	  case "green_d":			manageCSS("scrollbars_greendark.css"); manageCSS("fix_devtools.css"); break;	
	  case "blue_d":			manageCSS("scrollbars_bluedark.css"); manageCSS("fix_devtools.css"); break;
	  case "orange_d":			manageCSS("scrollbars_orangedark.css"); manageCSS("fix_devtools.css"); break;
	  case "pink_d":			manageCSS("scrollbars_pinkdark.css"); manageCSS("fix_devtools.css"); break;
	  case "yellow_d":			manageCSS("scrollbars_yellowdark.css"); manageCSS("fix_devtools.css"); break;
			
	  case "lightblue-w":		manageCSS("scrollbars_lightblue-w.css"); manageCSS("fix_devtools.css"); break;
	  case "red-w":				manageCSS("scrollbars_red-w.css"); manageCSS("fix_devtools.css"); break;
	  case "green-w":			manageCSS("scrollbars_green-w.css"); manageCSS("fix_devtools.css"); break;	
	  case "blue-w":			manageCSS("scrollbars_blue-w.css"); manageCSS("fix_devtools.css"); break;
	  case "orange-w":			manageCSS("scrollbars_orange-w.css"); manageCSS("fix_devtools.css"); break;
	  case "pink-w":			manageCSS("scrollbars_pink-w.css"); manageCSS("fix_devtools.css"); break;
	  case "yellow-w":			manageCSS("scrollbars_yellow-w.css"); manageCSS("fix_devtools.css"); break;	

	  case "lightblue_d-w": 	manageCSS("scrollbars_lightbluedark-w.css"); manageCSS("fix_devtools.css"); break;
	  case "red_d-w":			manageCSS("scrollbars_reddark-w.css"); manageCSS("fix_devtools.css"); break;
	  case "green_d-w":			manageCSS("scrollbars_greendark-w.css"); manageCSS("fix_devtools.css"); break;	
	  case "blue_d-w":			manageCSS("scrollbars_bluedark-w.css"); manageCSS("fix_devtools.css"); break;
	  case "orange_d-w":		manageCSS("scrollbars_orangedark-w.css"); manageCSS("fix_devtools.css"); break;
	  case "pink_d-w":			manageCSS("scrollbars_pinkdark-w.css"); manageCSS("fix_devtools.css"); break;
	  case "yellow_d-w":		manageCSS("scrollbars_yellowdark-w.css"); manageCSS("fix_devtools.css"); break;

	  // custom 1 styles
	  case "c1bglight":			manageCSS("scrollbars_custom1_bg_light.css");	break;
	  case "c1bgdark":			manageCSS("scrollbars_custom1_bg_dark.css");	break;
	  
	  case "custom1":
		
		manageCSS("scrollbars_custom1_base.css");
		
		removeOldSheet(this.custom1);
		
		if(enable==true){
			
		  // Get color code from preference.
		  var c1_colorpicker = this.prefs.getCharPref("custom1_colorpicker_thumb");
		  
		  var isValidHexcode = /^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$/i.test(c1_colorpicker);
		  if(!isValidHexcode) c1_colorpicker = '#33CCFF';
		  
		  // scrollbar size
		  var c1_scr_size = this.prefs.getIntPref("custom1_width");
		
		  // create a smaller scrollbarbutton size depending on main scrollbar size
		  var c1_scr_size2 = c1_scr_size/13*11;
		  				
		  this.custom1=ios.newURI("data:text/css;charset=utf-8," + encodeURIComponent('\
			@namespace url("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");\
			@namespace html url("http://www.w3.org/1999/xhtml");\
		    \
			scrollbar thumb:not(:hover):not(:active) {background-color: '+c1_colorpicker+' !important;}\
			scrollbar thumb:hover {background-color: '+c1_colorpicker+' !important;}\
			scrollbar thumb:active {background-color: '+c1_colorpicker+' !important;}\
			\
			scrollbar[orient="vertical"]{width: '+c1_scr_size+'px !important;}\
			scrollbar[orient="horizontal"]{height: '+c1_scr_size+'px !important;}\
			scrollbar[orient="vertical"] thumb {\
			  min-width: '+c1_scr_size+1+'px !important;\
			  max-width: '+c1_scr_size+1+'px !important;\
			}\
			scrollbar[orient="horizontal"] thumb {\
			  min-height: '+c1_scr_size+1+'px !important;\
			  max-height: '+c1_scr_size+1+'px !important;\
			}\
			\
			scrollbarbutton {\
				min-width: '+c1_scr_size+'px !important;\
				max-width: '+c1_scr_size+'px !important;\
				min-height: '+c1_scr_size+'px !important;\
				max-height: '+c1_scr_size+'px !important;\
			}\
			.thumb-topcap,.thumb-bottomcap {\
				min-width: '+c1_scr_size+'px !important;\
				max-width: '+c1_scr_size+'px !important;\
				min-height: '+c1_scr_size2+'px !important;\
				max-height: '+c1_scr_size2+'px !important;\
			}\
			.thumb-startcap,.thumb-endcap {\
				min-width: '+c1_scr_size2+'px !important;\
				max-width: '+c1_scr_size2+'px !important;\
				min-height: '+c1_scr_size+'px !important;\
				max-height: '+c1_scr_size+'px !important;\
			}\
			.thumb-vertical-body {\
				min-width: '+c1_scr_size+'px !important;\
				max-width: '+c1_scr_size+'px !important;\
			}\
			.thumb-horizontal-body {\
				min-height: '+c1_scr_size+'px !important;\
				max-height: '+c1_scr_size+'px !important;\
			}\
			scrollbar[orient="vertical"]{\
			  min-width: '+c1_scr_size+'px !important;\
			  max-width: '+c1_scr_size+'px !important;\
			}\
			scrollbar[orient="horizontal"]{\
			  min-height: '+c1_scr_size+'px !important;\
			  max-height: '+c1_scr_size+'px !important;\
			}\
		  '), null, null);

		  newscrollbarsjs.ns.loadUnloadCSS(this.prefs.getCharPref("custom1_bg"),true);

		  applyNewSheet(this.custom1);
		  
		  newscrollbarsjs.ns.loadUnloadCSS(this.prefs.getCharPref("custom1_grad"),true);

		}
		
		manageCSS("fix_devtools.css");
	  
	  break;
	  
	  case "c1gradlight":		manageCSS("scrollbars_custom1_grad_light.css");		break;
	  case "c1graddark":		manageCSS("scrollbars_custom1_grad_dark.css");		break;
	  
	  // custom 2 styles
	  case "custom2":
	  
	  	manageCSS("scrollbars_custom2_base.css");
		
		removeOldSheet(this.custom2);

		if(enable==true){
			
			// Get all settings needed for 'customizable scrollbars v2'
			var c2_bg = this.prefs.getCharPref("custom2_colorpicker_bg");
			var c2_thumb = this.prefs.getCharPref("custom2_colorpicker_thumb");
			var c2_thumbh = this.prefs.getCharPref("custom2_colorpicker_thumb_h");
			var c2_but = this.prefs.getCharPref("custom2_colorpicker_but");
			var c2_buth = this.prefs.getCharPref("custom2_colorpicker_but_h");
			var c2_size = this.prefs.getIntPref("custom2_size");
			var c2_borderradius = this.prefs.getIntPref("custom2_borderradius");
			var c2_butborderradius = this.prefs.getIntPref("custom2_butborderradius");
			var c2_opacity = this.prefs.getIntPref("custom2_opacity");
			
			var isValidHexcode_c2_bg = /^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$/i.test(c2_bg);
			if(!isValidHexcode_c2_bg) c2_bg = '#999999';
			
			var isValidHexcode_c2_thumb = /^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$/i.test(c2_thumb);
			if(!isValidHexcode_c2_thumb) c2_thumb = '#990000';
			
			var isValidHexcode_c2_thumbh = /^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$/i.test(c2_thumbh);
			if(!isValidHexcode_c2_thumbh) c2_thumbh = '#CC0000';
			
			var isValidHexcode_c2_but = /^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$/i.test(c2_but);
			if(!isValidHexcode_c2_but) c2_but = '#000000';
			
			var isValidHexcode_c2_buth = /^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$/i.test(c2_buth);
			if(!isValidHexcode_c2_buth) c2_buth = '#000066';

			// init background sheet-part
			var c2_scr_transp_bg='';
			var c2_bg_gradoverride='';
			
			if (this.prefs.getCharPref("custom2_bg")=='c2_bg_transparent'){
				c2_scr_transp_bg='\
					\
					#appcontent,#appcontent #content{\
						background-color: rgba(255,255,255, 0.0) !important;\
					}\
					scrollbar,scrollcorner{\
						-moz-appearance: -moz-win-borderless-glass !important;\
						border: 0 !important;\
						background: rgba(255,255,255, 0.0) !important;\
					}\
					scrollcorner{\
					  background: unset !important;\
					}\
					scrollbar[orient="vertical"],\
					scrollbar[orient="vertical"] > * {\
					  -moz-appearance: none !important;\
					  background: unset !important;\
					}\
					scrollbar[orient="horizontal"],\
					scrollbar[orient="horizontal"] > * {\
					  -moz-appearance: none !important;\
					  background: unset !important;\
					}\
				\
				';
			} else if (this.prefs.getCharPref("custom2_bg")=='c2_bg_line'){
				
				c2_bg_gradoverride='\
					\
					scrollbar[orient="vertical"],\
					scrollbar[orient="vertical"] > * {\
						-moz-appearance: none !important;\
						background: linear-gradient(to right, rgba(255,255,255, 0.0) 45%, '+c2_bg+', rgba(255,255,255, 0.0) 55%) !important;\
					}\
					scrollbar[orient="horizontal"],\
					scrollbar[orient="horizontal"] > * {\
						-moz-appearance: none !important;\
						background: linear-gradient(to top, rgba(255,255,255, 0.0) 45%, '+c2_bg+', rgba(255,255,255, 0.0) 55%) !important;\
					}\
				';
				
			}
			
			// init override part for 'scr on html' option
			var c2_scr_onhtml='';
			
			if (this.prefs.getBoolPref("custom2_scr_onhtml")==true){
				
				c2_scr_onhtml='\
					\
					html|* scrollbar[orient="vertical"] {\
						-moz-margin-start: -'+c2_size+'px !important;\
						width: '+c2_size+'px !important;\
						position: relative !important;\
						z-index: 999999999 !important;\
						-moz-box-align: start !important;\
					}\
					html|* scrollbar[orient="horizontal"] {\
						margin-top: -'+c2_size+'px !important;\
						height: '+c2_size+'px !important;\
						position: relative !important;\
						z-index: 999999999 !important;\
						-moz-box-align: start !important;\
					}\
				';
				
			}
			
			var c2_scr_opacity='';
			
			if (this.prefs.getIntPref("custom2_opacity")!=100){
				c2_scr_opacity='\
					\
					scrollbar {\
					  opacity: 0.'+c2_opacity+' !important;\
					}\
				';
			}
			
			var c2_thumb_border='';
			
			if (this.prefs.getCharPref("custom2_thumb_border")=="c2_thumbborder"){
				c2_thumb_border='\
					\
					scrollbar[orient="vertical"] thumb,\
					scrollbar[orient="horizontal"] thumb {\
					  box-shadow:	1px 0px 0px '+c2_bg+' inset,\
									0px 1px 0px '+c2_bg+' inset,\
									-1px 0px 0px '+c2_bg+' inset,\
									0px -1px 0px '+c2_bg+' inset !important;\
					}\
				';
			} else if (this.prefs.getCharPref("custom2_thumb_border")=="c2_thumbborder2"){
				c2_thumb_border='\
					\
					scrollbar[orient="vertical"] thumb,\
					scrollbar[orient="horizontal"] thumb {\
					  box-shadow:	2px 0px 0px '+c2_bg+' inset,\
									0px 2px 0px '+c2_bg+' inset,\
									-2px 0px 0px '+c2_bg+' inset,\
									0px -2px 0px '+c2_bg+' inset !important;\
					}\
				';
			}
			
			// Sheet for 'customizable scrollbars v2'
			this.custom2 = ios.newURI('data:text/css;charset=utf-8,' + encodeURIComponent('\
				@namespace url("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");\
				@namespace html url("http://www.w3.org/1999/xhtml");\
				\
				scrollcorner{\
				  background: '+c2_bg+' !important;\
				}\
				scrollbar[orient="vertical"],\
				scrollbar[orient="vertical"] > * {\
				  background: '+c2_bg+' !important;\
				}\
				scrollbar[orient="horizontal"],\
				scrollbar[orient="horizontal"] > * {\
				  background: '+c2_bg+' !important;\
				}\
				scrollbar thumb:not(:hover):not(:active) {background-color: '+c2_thumb+' !important;}\
				scrollbar thumb:hover {background-color: '+c2_thumbh+' !important;}\
				scrollbar thumb:active {background-color: '+c2_thumbh+' !important;}\
				\
				scrollbar[orient="vertical"]{width: '+c2_size+'px !important;}\
				scrollbar[orient="horizontal"]{height: '+c2_size+'px !important;}\
				scrollbar[orient="vertical"] thumb {\
				  min-width: '+c2_size+1+'px !important;\
				  max-width: '+c2_size+1+'px !important;\
				  border-radius: '+c2_borderradius+'px !important;}\
				\
				scrollbar[orient="horizontal"] thumb {\
				  min-height: '+c2_size+1+'px !important;\
				  max-height: '+c2_size+1+'px !important;\
				  border-radius: '+c2_borderradius+'px !important;}\
				\
				'+c2_bg_gradoverride+'\
				scrollbar[orient="vertical"] scrollbarbutton,\
				scrollbar[orient="horizontal"] scrollbarbutton,\
				scrollbar scrollbarbutton {\
					min-width: '+c2_size+'px !important;\
					max-width: '+c2_size+'px !important;\
					min-height: '+c2_size+'px !important;\
					max-height: '+c2_size+'px !important;\
					border-radius: '+c2_butborderradius+'px !important;\
					background-color: '+c2_but+' !important;\
					background-image: none !important;\
				}\
				scrollbar[orient="vertical"] scrollbarbutton:hover,\
				scrollbar[orient="horizontal"] scrollbarbutton:hover,\
				scrollbar scrollbarbutton:hover {\
					background-color: '+c2_buth+' !important;\
				}\
				\
				scrollbar[orient="vertical"]{\
				  min-width: '+c2_size+'px !important;\
				  max-width: '+c2_size+'px !important;\
				}\
				scrollbar[orient="horizontal"]{\
				  min-height: '+c2_size+'px !important;\
				  max-height: '+c2_size+'px !important;\
				}\
				\
				'+c2_scr_transp_bg+'\
				'+c2_scr_onhtml+'\
				'+c2_scr_opacity+'\
				'+c2_thumb_border+'\
				\
			'), null, null);
	  
		  applyNewSheet(this.custom2);
		  
		  newscrollbarsjs.ns.loadUnloadCSS(this.prefs.getCharPref("custom2_grad"),true);
		  
		}

		manageCSS("fix_devtools.css");
	  
	  break;
	  
	  case "menupopupfix":			manageCSS("menupopupfix.css");						break;
	  
	  case "c2lightgradient":		manageCSS("scrollbars_custom2_grad_light.css");		break;
	  case "c2darkgradient":		manageCSS("scrollbars_custom2_grad_dark.css");		break;

	}
	
	// Apply or remove the style sheet files
	function manageCSS(file) {

	  var sss = Cc["@mozilla.org/content/style-sheet-service;1"].getService(Ci.nsIStyleSheetService);
	  var ios = Services.io;

	  var uri = ios.newURI("chrome://noiascrollbars-extension/content/" + file,null,null);
		
	  try{
		if (enable) {
		  if (!sss.sheetRegistered(uri,sss.AGENT_SHEET)) sss.loadAndRegisterSheet(uri,sss.AGENT_SHEET);
		} else {
		  if (sss.sheetRegistered(uri,sss.AGENT_SHEET)) sss.unregisterSheet(uri,sss.AGENT_SHEET);
		}
	  }catch(e){}
	}

	// remove style sheet
	function removeOldSheet(sheet){

	  var sss = Cc["@mozilla.org/content/style-sheet-service;1"].getService(Ci.nsIStyleSheetService);

	  if (sss.sheetRegistered(sheet,sss.AGENT_SHEET)) sss.unregisterSheet(sheet,sss.AGENT_SHEET);
	}

	// apply style sheet
	function applyNewSheet(sheet){

	  var sss = Cc["@mozilla.org/content/style-sheet-service;1"].getService(Ci.nsIStyleSheetService);

	  try {
		if (!sss.sheetRegistered(sheet,sss.AGENT_SHEET)) sss.loadAndRegisterSheet(sheet,sss.AGENT_SHEET);
	  }catch(e){}
	}
	
  }

};

newscrollbarsjs.ns.init();

  global.newscrollbarsjs = newscrollbarsjs;
}(this));